/*

*/
import java.util.ArrayList;
import java.util.Scanner;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;

public class Part_1_ver1
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render.
      Scene scene = new Scene();
      scene.doLighting = false;
      scene.doSmoothLighting = false; // use flat shading
      scene.doBackFaceCulling = false;

      // Check for a file name on the command line.
      if ( 0 == args.length )
      {
         System.err.println("Usage: java Part_1_ver1 <OBJ file name>");
         System.exit(-1);
      }


      // Open the OBJ file named on the command line.




      // Get the geometry from the OBJ file
      // (assuming that all faces are triangles).





      /***************************************************/
      // THE REST OF THIS FILE DOES NOT NEED TO BE CHANGED.

      // Give the Scene a model matrix.
      scene.model2Identity();

      // Give the Scene a view matrix.
      scene.view2Identity();

      // Give the scene a projection matrix.
      scene.proj2Identity();

      // Set up the scene's view frustum.
      double fov    = 60.0;
      double aspect = 1.0;
      double near   = 1.0;
      double far    = 20.0;
      scene.projPerspective(fov, aspect, near, far);

      // Set up the scene's "camera".
      double eyex=0,    eyey=0,    eyez=10;
      double centerx=0, centery=0, centerz=0;
      double upx=0,     upy=1,     upz=0;
      scene.viewLookAt(eyex,    eyey,    eyez,
                       centerx, centery, centerz,
                       upx,     upy,     upz);

      // Set the Scene's viewport dimensions.
      scene.vp_width  = 512;
      scene.vp_height = 512;

      System.err.println( scene.toString(3) );

      // Create a framebuffer to render our scene into.
      FrameBuffer fb = new FrameBuffer(scene.vp_width, scene.vp_height);
      // Give the framebuffer a nice background color.
      fb.clearFB(java.awt.Color.darkGray);
      // Render our scene into the frame buffer.
      SceneRender.renderScene(scene, fb);
      // Save the resulting image in a file.
      String objName = args[0].substring( 1 + args[0].indexOf('\\'), args[0].indexOf(".") );
      fb.dumpFB2File( String.format(objName+"_ver1_%02d.ppm", 0) );

      // Spin the scene 360 degrees.
      for (int i = 1; i <= 36; i++)
      {
         // Rotate the scene by 10 degrees.
         scene.modelRotate(10, 0, 1, 0);
         // Render again.
         fb.clearFB(java.awt.Color.darkGray); // what happens if you don't clear the fb?
         SceneRender.renderScene(scene, fb);
         fb.dumpFB2File( String.format(objName+"_ver1_%02d.ppm", i) );
      }
   }
}