/*

*/
import java.util.ArrayList;
import java.util.Scanner;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.awt.Color;

public class Part_2
{
   public static void main(String[] args)
   {
      // Create the Scene object that we shall render
      Scene scene = new Scene();
      scene.doLighting = false;
      scene.doSmoothLighting = false; // use flat shading
      scene.doBackFaceCulling = false;

      // Check for a file name on the command line.
      if ( 0 == args.length )
      {
         System.err.println("Usage: java Part_2_demo <OBJ file name> [thickness]");
         System.exit(-1);
      }


      // Open the file named on the command line.
      // (Use your solution from Part_1_ver3.java.)


      // Get the geometry from the OBJ file.
      // (Use your solution to Part_1_ver3.java.)





      System.err.println("Finished reading " + args[0]);

      // Give the Scene a model matrix.
      scene.model2Identity();

      // Give the Scene a view matrix.
      scene.view2Identity();

      // Give the scene a projection matrix.
      scene.proj2Identity();

      // Set up the scene's view frustum.
      double fov    = 60.0;
      double aspect = 1.0;
      double near   = 1.0;
      double far    = 20.0;
      scene.projPerspective(fov, aspect, near, far);

      // Set up the scene's "camera".
      double eyex=0,    eyey=0,    eyez=10;
      double centerx=0, centery=0, centerz=0;
      double upx=0,     upy=1,     upz=0;
      scene.viewLookAt(eyex,    eyey,    eyez,
                       centerx, centery, centerz,
                       upx,     upy,     upz);

      // Set the Scene's viewport dimensions.
      scene.vp_width  = 512;
      scene.vp_height = 512;

      //System.err.println( scene.toString(3) );

      // Create a framebuffer to render our scene into.
      FrameBuffer fb = new FrameBuffer(scene.vp_width, scene.vp_height);
      // Give the framebuffer a nice background color.
      fb.clearFB(java.awt.Color.white);
      // Rotate the scene.
      scene.modelRotate(90, 0, 1, 0);
      // Render our scene into the frame buffer.
      System.err.println("Rendering " + args[0]);
      SceneRender.renderScene(scene, fb);

      System.err.println("Processing frambuffer for " + args[0]);

      // Process the contents of the frambuffer.
      /****************************************/




      //  Your solution to Part 2 goes here.




      /****************************************/
      // Save the resulting image in a file.
      String objName = args[0].substring( 1 + args[0].indexOf('\\'), args[0].indexOf(".") );
      fb.dumpFB2File( objName + ".ppm" );
      System.err.println("Saved " + objName + ".ppm");
   }//main()



}//Part_2